package application;
	




import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.WildcardType;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Optional;
import java.util.Scanner;
import java.util.Stack;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.stage.FileChooser;
import javafx.stage.Stage;
import javafx.util.Pair;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonBar.ButtonData;
import javafx.scene.control.ButtonType;
import javafx.scene.control.ColorPicker;
import javafx.scene.control.Dialog;
import javafx.scene.control.Label;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuBar;
import javafx.scene.control.MenuItem;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextField;
import javafx.scene.control.TextInputDialog;
import javafx.scene.control.ToggleGroup;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.*;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Line;
import javafx.scene.shape.Path;
import javafx.scene.shape.Polygon;
import javafx.scene.shape.Shape;
import javafx.scene.text.Font;
import javafx.event.*;


public class Main extends Application {
	


	Button newGraph ;
	Button Edge;
	Pane pane;
	VBox leftBox;
	BorderPane root;
	Button submit;
	TextField nameField;
	Color col = Color.RED;
	

	Graph graph = new Graph();
	int counter = 0;
	Node src,dest;
	String name = "addd.txt";
	boolean directEdge = false;
	boolean putGraph = false;
	boolean weight = false;
	boolean firstNode = false;
	boolean edge = false;
	boolean addW = false;
	boolean addName = false;
	boolean changeColor = false;
	boolean getShortest = false;
	boolean isCopy = false;
	boolean isPaste = false;
	boolean isCut = false;
	
	Vertics v1,v2,selected,copied;
	
	@Override
	public void start(Stage primaryStage) {
		try {
			

		

			root = new BorderPane();
			
			
			
			
			setStart();
			
			submit.setOnAction(ee -> { 
				System.out.println(directEdge);
				 pane = new Pane();
				 pane.setId("Center");
				root.setCenter(pane);
				 name = nameField.getText();
				 newGraph = new Button("Graph");
				 newGraph.setMinWidth(100);
				 newGraph.setMinHeight(40);
				 
				 Edge = new Button("Edge");
				 Edge.setMinWidth(100);
				 Edge.setMinHeight(40);
				 
				 Button addWeight = new Button("Weight");
				 addWeight.setMinWidth(100);
				 addWeight.setMinHeight(40);
				 addWeight.setOnAction(e -> {
					 addW = true;
				 });
				 
				 Button setName = new Button("Name");
				 setName.setMinWidth(100);
				 setName.setMinHeight(40);
				 setName.setOnAction(e -> {
					 addName = true;
				 });
				
				  ColorPicker colorPicker = new ColorPicker();
				  colorPicker.setMinWidth(100);
				  colorPicker.setMinHeight(40);
				  colorPicker.setValue(Color.RED);
				  colorPicker.getStyleClass().add("button");
				  colorPicker.setOnAction(e -> {
					  col = colorPicker.getValue();
					  changeColor = true;
				  });
				
				leftBox = new VBox(20);
				leftBox.setId("Left");
				leftBox.setMinWidth(100);
				leftBox.setAlignment(Pos.CENTER);
				
				
				leftBox.getChildren().addAll(newGraph,Edge,addWeight,setName,colorPicker);
				
				root.setLeft(leftBox);
				
			
				
				
				MenuBar topBar = new MenuBar();
				topBar.setId("TOP");
				
				Menu file = new Menu("File");
				
				MenuItem newProject = new MenuItem("New");
				MenuItem open = new MenuItem("Open");
				MenuItem save = new MenuItem("Save");
				MenuItem clear = new MenuItem("Clear");
				MenuItem close = new MenuItem("Close");
				
				
				
				file.getItems().addAll(newProject,open,save,clear,close);
				
				Menu edit = new Menu("Edit");
				MenuItem copy = new MenuItem("Copy");
				MenuItem paste = new MenuItem("Paste");
				MenuItem cut = new MenuItem("Cut");
				
				edit.getItems().addAll(copy,paste,cut);
				
				Menu run = new Menu("Run");
				MenuItem topSort = new MenuItem("Topological Sort");
				MenuItem shtPath = new MenuItem("Shortest Path");
				MenuItem mst = new MenuItem("MST");
				
				run.getItems().addAll(topSort,shtPath,mst);
				
				topBar.getMenus().addAll(file,edit,run);
				
				root.setTop(topBar);
				
				
				if (!weight) {
					addWeight.setDisable(true);
					mst.setDisable(true);
				}
				
				if (!directEdge) {
					topSort.setDisable(true);
				} else {
					mst.setDisable(true);
				}
				
				shtPath.setOnAction(e -> {
					getShortest = true;
				});
				
				newGraph.setOnAction(e -> {
					putGraph = true;
				});
				
				Edge.setOnAction(e -> {
					edge = true;

				});
				
				mst.setOnAction(e -> {
					edgeInfo[] er = MST.primMST(graph);
					
					for (int i = 0 ; i < er.length ; i ++) 
						System.out.println(er[i].d + "  " + er[i].s);
					try {
						drowNewPath(graph,er);
					} catch (CloneNotSupportedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				});
				
				topSort.setOnAction(e -> {
					try {
						Stack<Integer> st = Sort.topologicalSort(graph);
						HBox buttomBox = new HBox(8);
						buttomBox.setAlignment(Pos.CENTER);
						while (!st.isEmpty()) {
							System.out.println("aaa");
							Label lab = new Label(graph.myGraph.get((int)st.pop()).name);
							lab.setFont(Font.font(30));
							lab.setTextFill(Color.RED);
							buttomBox.getChildren().add(0, lab);
						}
						
						buttomBox.setLayoutX(150);
						buttomBox.setLayoutY(500);
						pane.getChildren().add(buttomBox);	
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				});
	
				newProject.setOnAction(e ->  {
					setEveryThing();
					start(primaryStage);
				});
				save.setOnAction(e -> save());
				open.setOnAction(e -> open());
				
				copy.setOnAction(e -> {
					isCopy = true;
				});
				
				cut.setOnAction(e -> {
					isCopy = true;
					isCut = true;
					
				});
				
				paste.setOnAction(e ->  {
					isPaste = true;
					isCopy = false;
				});
			
				
				pane.addEventHandler(MouseEvent.MOUSE_CLICKED, (MouseEvent e) -> {
					
					if (isPaste) {
						Circle c = new Circle(e.getX(),e.getY(),20,col);
						

						if (isCut) {
							Vertics v = new Vertics(c,copied.number,copied.name);
							addEventHandler(pane,v);
							pane.getChildren().add(v);
							Label ll = new Label(v.name);
							ll.setLayoutX(v.x-15);
							ll.setLayoutY(v.y-25);
							
							graph.myGraph.add(v);
							pane.getChildren().add(ll);
							for (int i = 0 ; i < graph.myGraph.size() ; i++) {
								if (graph.myGraph.get(i) == copied) {
									graph.myGraph.remove(i);
									break;
								}
							}
							delete(copied);
							isCut = false;
							
						} else {
							Vertics v = new Vertics(c,counter++,copied.name);
							pane.getChildren().add(v);
							addEventHandler(pane,v);
							graph.myGraph.add(v);
							Label ll = new Label(v.name);
							ll.setLayoutX(v.x-15);
							ll.setLayoutY(v.y-25);
							pane.getChildren().add(ll);
						}
						
						isPaste = false;
					}
					
					if (e.getButton().equals(MouseButton.PRIMARY)) {
						if (putGraph) {
											
								Circle c = new Circle(e.getX(), e.getY(), 20,col);
								
								Vertics v = new Vertics(c,counter++,"V");
								graph.myGraph.add(v);
								addEventHandler(pane, v);
								pane.getChildren().add(v);
								
								
								
							putGraph = false;
						} 
					}
					
				});
				
				
				
				
			});
			
			Scene scene = new Scene(root,800,600);
			scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.show();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		
	}
	
	
	public void setStart( ) {
		ToggleGroup t1 = new ToggleGroup();
		RadioButton weightd = new RadioButton("Wegihted");
		weightd.setUserData("W");
		weightd.setToggleGroup(t1);
		weightd.setOnAction(e -> {
			weight = true;
		});
		RadioButton unweightd = new RadioButton("Unwegihted");
		unweightd.setUserData("U");
		unweightd.setToggleGroup(t1);
		unweightd.setOnAction(e -> {
			weight = false;
		});
		HBox t1Box = new HBox(10);
		t1Box.getChildren().addAll(weightd,unweightd);
		
		ToggleGroup t2 = new ToggleGroup();
		RadioButton direct = new RadioButton("Directed");
		direct.setUserData("D");
		direct.setToggleGroup(t2);
		direct.setOnAction(e -> {
			directEdge = true;
		});
		RadioButton undirect = new RadioButton("Undirected");
		undirect.setUserData("U");
		undirect.setToggleGroup(t2);
		HBox t2Box = new HBox(10);
		undirect.setOnAction(e -> {
			directEdge = false;
		});
		t2Box.getChildren().addAll(direct,undirect);
		
		Label nameLabel = new Label("Name : ");
		Label options = new Label("Options");
		 nameField = new TextField();
		submit = new Button("Submit");
		
		GridPane leftGridPane = new GridPane();
		leftGridPane.setVgap(20);
		leftGridPane.setAlignment(Pos.CENTER);
		leftGridPane.add(nameLabel, 0, 0);
		leftGridPane.add(nameField, 1, 0);
		leftGridPane.add(options, 0, 1);
		leftGridPane.add(t1Box, 1, 2);
		leftGridPane.add(t2Box, 1, 4);
		leftGridPane.add(submit, 1, 6);
		
		
		VBox newLeftBox = new VBox(20);
		newLeftBox.getChildren().add(leftGridPane);
		newLeftBox.setAlignment(Pos.CENTER);
		root.setCenter(newLeftBox);
		
	}
	
	

	
	public void addEventHandler(Pane parent, Node node) {
		
	
		node.addEventHandler(MouseEvent.MOUSE_CLICKED, (MouseEvent e) -> {    
			System.out.println(edge + " " + firstNode);
			if (e.getButton().equals(MouseButton.PRIMARY)) {
				
				if (node instanceof DirectEdge && addW) {
					System.out.println("aaaa");
					 TextInputDialog dialog = new TextInputDialog("weight");
						dialog.setTitle("weight dialog");
						dialog.setHeaderText("Set Weight");
						dialog.setContentText("Please enter the weight:");
						Optional<String> result = dialog.showAndWait();
						int weight = Integer.parseInt(result.get());
						Vertics p1 = ((DirectEdge)node).s;
						Vertics p2 = ((DirectEdge)node).d;
						((DirectEdge)node).weight = weight;
						if (result.isPresent() ) {
							Label ll =	((DirectEdge) node).l;
							ll.setText(weight +"");
							ll.setLayoutX( ((2 * p1.x) / 3) + (p2.x) / 3 );
							ll.setLayoutY( ((2 * p1.y) / 3) + (p2.y) / 3 );
							ll.setTextFill(Color.RED);
							pane.getChildren().add(ll);
						}
						addW = false;
				}
				
				

				if (node instanceof UndirectEdge && addW) {
					 TextInputDialog dialog = new TextInputDialog("weight");
						dialog.setTitle("weight dialog");
						dialog.setHeaderText("Set Weight");
						dialog.setContentText("Please enter the weight:");
						Optional<String> result = dialog.showAndWait();
						int weight = Integer.parseInt(result.get());
						Vertics p1 = ((UndirectEdge)node).s;
						Vertics p2 = ((UndirectEdge)node).d;
						((UndirectEdge)node).weight = weight;
						if (result.isPresent() ) {
							Label ll = ((UndirectEdge)node).l;
							ll.setText(weight +"");
							ll.setLayoutX((p1.x + p2.x) / 2 );
							ll.setLayoutY((p1.y + p2.y) / 2);
							ll.setTextFill(Color.RED);
							pane.getChildren().add(ll);

							for (int i = 0 ; i < graph.myGraph.size() ; i++) {
								for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
									if (graph.myGraph.get(i).undirect.get(j).s == p2 && graph.myGraph.get(i).undirect.get(j).d == p1) {
										graph.myGraph.get(i).undirect.get(j).weight = weight;
										break;
									}
								}
							}
						}
						
						addW = false;
				}
				
				
				if (e.getClickCount() == 1 && node instanceof Vertics) {
					
					System.out.println(directEdge);
					selected = (Vertics) node;
					if (getShortest) {
						System.out.println("hahahaha");
						if (v1 != null) {
							v2 = (Vertics)node;
							if (directEdge) {
								try {
									edgeInfo[] path = shortestPath.directedAlgorithm(graph,v1,v2);
									drowNewPath(graph,path);
									v1 = null;
									v2 = null;
								} catch (Exception e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							} else {
								try {
									edgeInfo[] path = shortestPath.undirectedAlgorithm(graph,v1,v2);
									drowNewPath(graph,path);
									v1 = null;
									v2 = null;
									getShortest = false;
								} catch (Exception e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} else {
							v1 = (Vertics)node;
						}
						
					}
					
					
					
					
					
					if (edge) {
						if (directEdge) {
							
							if (firstNode) {
								v2 = (Vertics) node;
								int w = 1;
												
									DirectEdge de = new DirectEdge(v1,v2,w,new Label(w+""));
									addEventHandler(pane,de);
									 v1.addDirect(de);
									 pane.getChildren().add(de);
								
								edge = false;
								firstNode = false;
								v1 = null;
								v2 = null;
							} else  {
								v1 = (Vertics) node;
								firstNode = true;
							}
							
			
						} else {

							if (firstNode) {
								v2 = (Vertics) node;
								int w = 1;						
							
									UndirectEdge ue = new UndirectEdge(v1,v2,w,new Label(w +""));
									 v1.addUndirect(ue);
									 addEventHandler(pane,ue);
									 pane.getChildren().add(ue);
									 UndirectEdge ue1 = new UndirectEdge(v2,v1,w,new Label(w + ""));
									 addEventHandler(pane,ue1);
									 v2.addUndirect(ue1);
								
								edge = false;
								firstNode = false;
								v1 = null;
								v2 = null;
							}  else  {
								v1 = (Vertics) node;
								firstNode = true;
							}				
							
						}
						
						
					} else if (addName) {
							TextInputDialog dialog = new TextInputDialog("Name");
							dialog.setTitle("name dialog");
							dialog.setHeaderText("Set name");
							dialog.setContentText("Please enter the name:");
							Optional<String> result = dialog.showAndWait();
							String n = result.get();
							selected.name = n;
							Label l = new Label(n);
							l.setLayoutX(selected.x-10);
							l.setLayoutY(selected.y-25);
							pane.getChildren().add(l);
							addName = false;
					} else if (changeColor) {
						selected.setFill(col);
						changeColor = false;
					} else if (isCopy) {
						copied = (Vertics) node;
					} 
					
				} else if (e.getClickCount() == 2) {
					delete(node);
				}
					
			}
		});
		
		
		
	}
	
	public void delete(Node node) {
		if (node instanceof Vertics) {
			counter--;
			double x = ((Vertics)node).x;
			double y = ((Vertics)node).y;
			pane.getChildren().remove(node);
			
			for (int i = 0 ; i < graph.myGraph.size() ; i++) {
				if (graph.myGraph.get(i).equals((Vertics)node)) {
					graph.myGraph.remove(i);
					break;
				}
			}
			
			for (int i = 0 ; i < pane.getChildren().size() ; i++) {
				if (pane.getChildren().get(i) instanceof DirectEdge) {
							if (((DirectEdge) pane.getChildren().get(i)).getStartX() == x && ((DirectEdge) pane.getChildren().get(i)).getStartY() == y) {      
								Label df = ((DirectEdge) pane.getChildren().get(i)).l;
								pane.getChildren().remove(i);
								if(weight) {
									pane.getChildren().remove(df);
									
								}
								i--;
								
							} else if (((DirectEdge) pane.getChildren().get(i)).getEndX() == x && ((DirectEdge) pane.getChildren().get(i)).getEndY() == y) {
								Label df = ((DirectEdge) pane.getChildren().get(i)).l;
								pane.getChildren().remove(i);
								if(weight) {
									pane.getChildren().remove(df);
									
								}
								i--;
							}
				} else if (pane.getChildren().get(i) instanceof UndirectEdge) {
					if (((UndirectEdge) pane.getChildren().get(i)).getStartX() == x && ((UndirectEdge) pane.getChildren().get(i)).getStartY() == y) {      
						Label df = ((UndirectEdge) pane.getChildren().get(i)).l;
						pane.getChildren().remove(i);
						if(weight) {
							pane.getChildren().remove(df);
							
						}
						i--;
					} else if (((UndirectEdge) pane.getChildren().get(i)).getEndX() == x && ((UndirectEdge) pane.getChildren().get(i)).getEndY() == y) {
						Label df = ((UndirectEdge) pane.getChildren().get(i)).l;
						pane.getChildren().remove(i);
						if(weight) {
							pane.getChildren().remove(df);
							
						}
						i--;
					}
				} else if (pane.getChildren().get(i) instanceof Label) {
					if (((Label) pane.getChildren().get(i)).getLayoutX() == x-10 && ((Label) pane.getChildren().get(i)).getLayoutY() == y-25) {
						
						pane.getChildren().remove(i);
						
						i--;
					}
				}
			}	
			
			if (!directEdge) {
				for (int i = 0 ; i < graph.myGraph.size() ; i++) {
					for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
						if (graph.myGraph.get(i).undirect.get(j).d.x == x && graph.myGraph.get(i).undirect.get(j).d.y == y) {
							
							graph.myGraph.get(i).undirect.remove(j);
							
						}
					}
				}
			} else {
				for (int i = 0 ; i < graph.myGraph.size() ; i++) {
					for (int j = 0 ; j < graph.myGraph.get(i).direct.size() ; j++) {
						if (graph.myGraph.get(i).direct.get(j).d.x == x && graph.myGraph.get(i).direct.get(j).d.y == y) {
							graph.myGraph.get(i).direct.remove(j);
						}
					}
				}
			}
		} else if (node instanceof UndirectEdge) {
			 double x1 = ((UndirectEdge)node).d.x;
			 double y1 = ((UndirectEdge)node).d.y;
			 
			 double x2 = ((UndirectEdge)node).s.x;
			 double y2 = ((UndirectEdge)node).s.y;
			 
			 for (int i = 0 ; i < graph.myGraph.size() ; i++) {
				 for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
					 if ((graph.myGraph.get(i).undirect.get(j).s.x == x2 && graph.myGraph.get(i).undirect.get(j).s.y == y2) 
							 || (graph.myGraph.get(i).undirect.get(j).s.x == x1 && graph.myGraph.get(i).undirect.get(j).s.y == y1)) {
						
						 graph.myGraph.get(i).undirect.remove(j);
						
					 }
						 
				 }
			 } 
			 
			 pane.getChildren().remove(node);
			 if (weight) {
			 Label df = ((UndirectEdge)node).l;
			 
			 pane.getChildren().remove(df);
			 }
		} else if (node instanceof DirectEdge) {
			double x1 = ((DirectEdge)node).s.x;
			 double y1 = ((DirectEdge)node).s.y; 
			 
			 for (int i = 0 ; i < graph.myGraph.size() ; i++) {
				 for (int j = 0 ; j< graph.myGraph.get(i).direct.size() ; j++) {
					 
					 if (graph.myGraph.get(i).direct.get(j).s.x == x1 && graph.myGraph.get(i).direct.get(j).s.y == y1) {
						 graph.myGraph.get(i).direct.remove(j);
					 }
				 }
			 }
			
			 pane.getChildren().remove(node);
			 if (weight) {
			 Label df = ((DirectEdge)node).l;
			 pane.getChildren().remove(df);
			 }
		}else {
			 pane.getChildren().remove(node);
		}
	}
	

	
	
	public void drowNewPath(Graph g, edgeInfo[] arr) throws CloneNotSupportedException {
		Pane p2 = new Pane();
		Stage st = new Stage();
		Scene s = new Scene(p2,600,600);
		
		for (int i = 0 ; i < g.myGraph.size() ; i++) {
			 p2.getChildren().add((Vertics)g.myGraph.get(i).clone());
			 
		 }
		 
		 for (int i = 0 ; i < graph.myGraph.size() ; i++) {
			 for (int j = 0 ; j < graph.myGraph.get(i).direct.size() ; j++) {
				 p2.getChildren().add((DirectEdge)graph.myGraph.get(i).direct.get(j).clone());
				 if (weight) {
					 Label lab = new Label(graph.myGraph.get(i).direct.get(j).weight +"");
					 lab.setLayoutX( ((2 * graph.myGraph.get(i).direct.get(j).s.x) / 3) + (graph.myGraph.get(i).direct.get(j).d.x) / 3 );
					 lab.setLayoutY( ((2 * graph.myGraph.get(i).direct.get(j).s.y) / 3) + (graph.myGraph.get(i).direct.get(j).d.y) / 3 );
					 lab.setTextFill(Color.RED);
					 p2.getChildren().add(lab);
				 }
			 }
			 
			 for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
				 p2.getChildren().add((UndirectEdge)graph.myGraph.get(i).undirect.get(j).clone());
				 Label lab = new Label(graph.myGraph.get(i).undirect.get(j).weight +"");
				 lab.setLayoutX( (graph.myGraph.get(i).undirect.get(j).s.x + graph.myGraph.get(i).undirect.get(j).d.x) / 2 );
				 lab.setLayoutY( (graph.myGraph.get(i).undirect.get(j).s.y + graph.myGraph.get(i).undirect.get(j).d.y) / 2 );
				 lab.setTextFill(Color.RED);
				 p2.getChildren().add(lab);
			 }
			 
		 }
		 
		 
		 for (int i = 0 ; i < arr.length ; i++) {
				
				if (directEdge) {
					for (int j = 0 ; j < graph.myGraph.size() ; j++) {
						for (int k = 0 ; k < graph.myGraph.get(j).direct.size() ; k++) {
							if ( graph.myGraph.get(j).direct.get(k).s.number == arr[i].s
									&& graph.myGraph.get(j).direct.get(k).d.number == arr[i].d) {
								Line l2 = new Line();
								l2.setStartX(graph.myGraph.get(j).direct.get(k).s.x);
								l2.setStartY(graph.myGraph.get(j).direct.get(k).s.y);
								l2.setEndX(graph.myGraph.get(j).direct.get(k).d.x);
								l2.setEndY(graph.myGraph.get(j).direct.get(k).d.y);
								l2.setStroke(Color.DEEPPINK);
								l2.setStrokeWidth(3);
								p2.getChildren().add(l2);
								break;
							}
						}
					}
					
				} else {
					for (int j = 0 ; j < graph.myGraph.size() ; j++) {
						for (int k = 0 ; k < graph.myGraph.get(j).undirect.size() ; k++) {
							if ( graph.myGraph.get(j).undirect.get(k).s.number == arr[i].s
									&& graph.myGraph.get(j).undirect.get(k).d.number == arr[i].d) {
								Line l2 = new Line();
								l2.setStartX(graph.myGraph.get(j).undirect.get(k).s.x);
								l2.setStartY(graph.myGraph.get(j).undirect.get(k).s.y);
								l2.setEndX(graph.myGraph.get(j).undirect.get(k).d.x);
								l2.setEndY(graph.myGraph.get(j).undirect.get(k).d.y);
								l2.setStroke(Color.DEEPPINK);
								p2.getChildren().add(l2);
								break;
							} else if (graph.myGraph.get(j).undirect.get(k).d.number == arr[i].s
									&& graph.myGraph.get(j).undirect.get(k).s.number == arr[i].d) {
								Line l2 = new Line();
								l2.setStartX(graph.myGraph.get(j).undirect.get(k).s.x);
								l2.setStartY(graph.myGraph.get(j).undirect.get(k).s.y);
								l2.setEndX(graph.myGraph.get(j).undirect.get(k).d.x);
								l2.setEndY(graph.myGraph.get(j).undirect.get(k).d.y);
								l2.setStroke(Color.DEEPPINK);
								p2.getChildren().add(l2);
							}
						}
					}
				}
				
			}
		 
		 st.setScene(s);
		 st.show();

		
	}
	

	 
	 
	 void save() {
		 
		 for (int i = 0 ; i < graph.myGraph.size() ; i++) {
			 graph.myGraph.get(i).number = i;
		 }
		 
		 try {
			FileWriter out = new FileWriter(new File(name + ".txt"));
			
			
			out.write(graph.myGraph.size() + "\n");
			
			if (directEdge)
				out.write("direct\n");
			else 
				out.write("undirect\n");
			if (weight)
				out.write("weight\n");
			else
				out.write("unweight\n");
			
			for (int i = 0 ; i < graph.myGraph.size() ; i++) {
				if (directEdge) {
					out.write(graph.myGraph.get(i).name + " " + graph.myGraph.get(i).number + " " + graph.myGraph.get(i).direct.size()+"\n");
					
					out.write(graph.myGraph.get(i).x + " " + graph.myGraph.get(i).y +"\n");
					
					for (int j = 0 ; j < graph.myGraph.get(i).direct.size() ; j++) {
						out.write(graph.myGraph.get(i).direct.get(j).d.number + " " + graph.myGraph.get(i).direct.get(j).weight+"\n");
					}
				} else {
					out.write(graph.myGraph.get(i).name + " " + graph.myGraph.get(i).number + " " + graph.myGraph.get(i).undirect.size()+"\n");
					
					out.write(graph.myGraph.get(i).x + " " + graph.myGraph.get(i).y +"\n");
					
					for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
						out.write(graph.myGraph.get(i).undirect.get(j).d.number + " " + graph.myGraph.get(i).undirect.get(j).weight+"\n");
					}
				}
			}
			out.close();
			
			
			
			
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		 
		 
	 }
	 
	 
	 
	 public void setEveryThing() {
		 directEdge = false;
		 putGraph = false;
		 weight = false;
	     firstNode = false;
		 edge = false;
		 pane.getChildren().clear();
		 graph = new Graph();

		 
		  graph = new Graph();
		 counter = 0;
		 src = null;
		 dest = null;
		 name = "form.txt";
			 addW = false;
			 addName = false;
			 changeColor = false;
			 getShortest = false;
	 }
	 
	 
	 
	 void open() {
		 setEveryThing();


		 File file;
		 FileChooser fileChooser = new FileChooser();
			fileChooser.setTitle("Open Resource File");
			file = fileChooser.showOpenDialog(null);
			name = file.getName();
			 
			try {
				Scanner scan = new Scanner(file);
				
				int size = scan.nextInt();
				String dd = scan.next();
				String ff = scan.next();
				
				if (dd.equals("direct")) 
					directEdge = true;
				else
					directEdge = false;
				
				if (ff.equals("weight")) 
					weight = true;
				else
					weight= false;
				
					
				
				edgeInfo[] arr = new edgeInfo[size * size];
				int si = 0;
				
				for (int i = 0 ; i < size ; i++) {
					String name = scan.next();
					int num = scan.nextInt();
					int eSize = scan.nextInt();
					double x = scan.nextDouble();
					double y = scan.nextDouble();
					
					Circle c = new Circle(x,y,20,col);
					Vertics v = new Vertics(c,num,name);
					graph.myGraph.add(v);
					addEventHandler(pane, v);
					
					for (int j = 0 ; j < eSize  ; j++) {
						arr[si++] = new edgeInfo(num, scan.nextInt(), scan.nextInt());
					}
				}
				
				for (int i = 0 ; i < si ; i++) {
					
					if (directEdge) {
						int id = arr[i].s;
						DirectEdge ee = new DirectEdge(graph.myGraph.get(id), graph.myGraph.get(arr[i].d), arr[i].w, new Label(arr[i].w + ""));
						graph.myGraph.get(id).direct.add(ee);
					} else {
						int id = arr[i].s;
						UndirectEdge ee = new UndirectEdge(graph.myGraph.get(id), graph.myGraph.get(arr[i].d), arr[i].w,new Label(arr[i].w + ""));
						graph.myGraph.get(id).undirect.add(ee);
					}
					
				}
				
				drowGraph(graph);
				
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
		 
	 }
	 
	 void drowGraph(Graph g) {
		 for (int i = 0 ; i < g.myGraph.size() ; i++) {
			 pane.getChildren().add(g.myGraph.get(i));
			 
		 }
		 
		 for (int i = 0 ; i < graph.myGraph.size() ; i++) {
			 for (int j = 0 ; j < graph.myGraph.get(i).direct.size() ; j++) {
				 pane.getChildren().add(graph.myGraph.get(i).direct.get(j));
				 if (weight) {
					 Label lab = graph.myGraph.get(i).direct.get(j).l;
					 lab.setLayoutX( ((2 * graph.myGraph.get(i).direct.get(j).s.x) / 3) + (graph.myGraph.get(i).direct.get(j).d.x) / 3 );
					 lab.setLayoutY( ((2 * graph.myGraph.get(i).direct.get(j).s.y) / 3) + (graph.myGraph.get(i).direct.get(j).d.y) / 3 );
					 lab.setTextFill(Color.RED);
					 pane.getChildren().add(lab);
				 }
			 }
			 
			 for (int j = 0 ; j < graph.myGraph.get(i).undirect.size() ; j++) {
				 pane.getChildren().add(graph.myGraph.get(i).undirect.get(j));
				 Label lab = graph.myGraph.get(i).undirect.get(j).l;
				 lab.setLayoutX( (graph.myGraph.get(i).undirect.get(j).s.x + graph.myGraph.get(i).undirect.get(j).d.x) / 2 );
				 lab.setLayoutY( (graph.myGraph.get(i).undirect.get(j).s.y + graph.myGraph.get(i).undirect.get(j).d.y) / 2 );
				 lab.setTextFill(Color.RED);
				 pane.getChildren().add(lab);
			 }
			 
		 }

	 }
	 

	 

	 
	 
	 
	 void clear () {
		 setEveryThing();

	 }
	
	public static void main(String[] args) {
		launch(args);
	}
}
