package application;

import java.util.ArrayList;

public class shortestPath {
	
	static int minDist(int[] dist , boolean [] visited) {
		int min = Integer.MAX_VALUE;
		int min_index = -1;
		
		for (int i = 0 ; i < dist.length; i++) {
			if (visited[i] == false && dist[i] <= min) {
				min = dist[i];
				min_index = i;
			}
		}
		return min_index;
	}
	
	static edgeInfo[] directedAlgorithm(Graph g, Vertics ss , Vertics ee) throws Exception {
		
		
		for (int i = 0 ; i < g.myGraph.size() ; i++) {
			g.myGraph.get(i).number = i;
		}
		int start = ss.number;
		int end = ee.number;
		int[] distance = new int[g.myGraph.size()]; // dv
		boolean[] visit = new boolean[g.myGraph.size()]; // known
		int[] path = new int[g.myGraph.size()]; // d
		int[] cost = new int[g.myGraph.size()]; 
		
		for (int i = 0 ; i < g.myGraph.size() ; i++) {
			distance[i] = Integer.MAX_VALUE;
			visit[i] = false;
			path[i] = -1;
			cost[i] = -1;
		}
		
		distance[start] = 0;
		
		for (int i = 0 ; i < g.myGraph.size() - 1 ; i++) {
			int u = minDist(distance,visit);
			visit[u] = true;
			
			for (int j = 0 ; j < g.myGraph.get(u).direct.size() ; j++) {
				if (!visit[g.myGraph.get(u).direct.get(j).d.number] && g.myGraph.get(u).direct.get(j).weight + distance[u] < distance[g.myGraph.get(u).direct.get(j).d.number]) {
					distance[g.myGraph.get(u).direct.get(j).d.number] = g.myGraph.get(u).direct.get(j).weight + distance[u];
					path[g.myGraph.get(u).direct.get(j).d.number ] = u;
					cost[g.myGraph.get(u).direct.get(j).d.number ] = g.myGraph.get(u).direct.get(j).weight;
				}
			}
		}
		
		for (int i = 0 ; i < path.length ; i++)
			System.out.println(path[i]);
		
		
		int d = end;
		int r = -2;
		ArrayList<edgeInfo> track = new ArrayList<>();
		if (r != -1) {
			while (r != start) {
				
				r = path[d];

				System.out.println(r + " " + d);
				track.add(new edgeInfo(r,d,cost[d]));
				d = r;
				
			}
		}
		
		edgeInfo[] ed = new edgeInfo[track.size()];
		
		for (int i = track.size() - 1 ; i >= 0 ; i--) {
			ed[i] = new edgeInfo(track.get(i).s,track.get(i).d,track.get(i).w);
		}
		return ed;
		
		
	}







static edgeInfo[] undirectedAlgorithm(Graph g, Vertics ss , Vertics ee) throws Exception {
	
	for (int i = 0 ; i < g.myGraph.size() ; i++) {
		g.myGraph.get(i).number = i;
	}
	int start = ss.number;
	int end = ee.number;
	
	int[] distance = new int[g.myGraph.size()];
	boolean[] visit = new boolean[g.myGraph.size()];
	int[] path = new int[g.myGraph.size()];
	int[] cost = new int[g.myGraph.size()];
	
	for (int i = 0 ; i < g.myGraph.size() ; i++) {
		distance[i] = Integer.MAX_VALUE;
		visit[i] = false;
		path[i] = -1;
		cost[i] = -1;
	}
	
	distance[start] = 0;
	
	for (int i = 0 ; i < g.myGraph.size() - 1 ; i++) {
		int u = minDist(distance,visit);
		visit[u] = true;
		
		for (int j = 0 ; j < g.myGraph.get(u).undirect.size() ; j++) {
			if (!visit[g.myGraph.get(u).undirect.get(j).d.number] && g.myGraph.get(u).undirect.get(j).weight + distance[u] < distance[g.myGraph.get(u).undirect.get(j).d.number]) {
				distance[g.myGraph.get(u).undirect.get(j).d.number] = g.myGraph.get(u).undirect.get(j).weight + distance[u];
				path[g.myGraph.get(u).undirect.get(j).d.number ] = u;
				cost[g.myGraph.get(u).undirect.get(j).d.number ] = g.myGraph.get(u).undirect.get(j).weight;
			}
		}
	}
	
	
	int d = end;
	int r = -2;
	ArrayList<edgeInfo> track = new ArrayList<>();
	if (r != -1) {
		while (r != start) {
			System.out.println(r + " >>> " + d);
			r = path[d];
			System.out.println(r + " " + d);
			track.add(new edgeInfo(r,d,cost[d]));
			d = r;
			
		}
	}
	
	edgeInfo[] ed = new edgeInfo[track.size()];
	
	for (int i = track.size() - 1 ; i >= 0 ; i--) {
		ed[i] = new edgeInfo(track.get(i).s,track.get(i).d,track.get(i).w);
	}
	return ed;
	
	
}

}


